#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Common;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using System.Collections.Generic;

namespace HeuristicLab.Core.Networks {
  [StorableClass]
  [Item("MessageValueCollection", "Represents a collection of message values.")]
  public class MessageValueCollection : KeyedItemCollection<string, IMessageValue> {
    [StorableConstructor]
    protected MessageValueCollection(bool deserializing) : base(deserializing) { }
    protected MessageValueCollection(MessageValueCollection original, Cloner cloner) : base(original, cloner) { }
    public MessageValueCollection() : base() { }
    public MessageValueCollection(int capacity) : base(capacity) { }
    public MessageValueCollection(IEnumerable<IMessageValue> collection) : base(collection) { }

    public override IDeepCloneable Clone(Cloner cloner) { return new MessageValueCollection(this, cloner); }

    protected override string GetKeyForItem(IMessageValue item) {
      return item.Name;
    }
  }
}
